Subject: bug#22991: 25.0.92: C-u C-s does not display "Regexp I-search:" in the echo area

From: Drew Adams <[email-masked]>
Date: Sat, 12 Mar 2016 15:11:59 -0800 (PST)

> > 1. I agree with Michael in this case.  The prompt should
> > faithfully reflect the current search state/mode - until we
> > find a better way to convey that information.  In any case,
> > the prompt should not mislead by reflecting a different
> > search behavior from what is current.
> 
> Reflecting all current search states might produce overly long
> default prompts as
> 
>   Character-folding case-folding whitespace-folding I-search:

Precisely.  The prompt is not the place for such information.
It might have sufficed when we had only regexp and literal.
But even then it did not express that state of case-folding.
And when "lax" whitespace matching was introduced it already
led to less clarity.

> >> 4. All of that said, I think that we really need to find
> >> some _other way than the prompt_ to indicate, completely,
> >> the search state.  And then the prompt can perhaps just be
> >> something like "Isearch" in all cases.  The prompt is not
> >> adequate for conveying just what the current search state is.
> >
> > Something that I think should be available, starting now, is
> > an Isearch key binding that describes the current search state
> > _completely_, much as `C-u C-x =' describes the char at point.
> >
> > This state information should be on prefix key `C-h'.  It
> > could be on a new key on that prefix or it could simply be
> > added to `isearch-describe-mode' - the key could be `C-h m'.
> 
> Or an option/state (say, ‘isearch-message-verbose’) toggleable
> with ‘isearch-toggle-message-verbose’ like other states
> (e.g. ‘isearch-toggle-case-fold’) that will toggle between
> displaying full/brief state description in the prompt.

No.  The point is that the prompt is inadequate for showing
search state/mode.  A more general discussion, and perhaps
more imagination, is needed to find one or more good solutions.

There was some discussion on emacs-devel already, including
suggestions about the mode-line and others, but nothing was
decided, and probably there are better suggestions to be
invented yet.

In the meantime, I suggest we anyway provide complete such
information on a help key.  This "solution" can remain,
regardless of whatother designs might be adopted to provide
some such info all of the time (instead of just on demand).

IOW, add the complete info to a help command now, in any
case.  For the rest, open another discussion on emacs-devel.

Wrt this bug and the prompt, for now: Either drop any
indication of state in the prompt (which might confuse
people) or show only what we showed before (regexp vs
literal), ignoring indicating char folding, case folding,
and whitespace folding.

Char folding, in particular, has introduced complication
in the traditional Isearch UI.  Indicating the current
state is just one such complication.  Char folding is an
area still in the process of definition, which means that
it is anyway likely that its effects on the UI are not
ready to be understood completely or decided now.

So let's be conservative wrt prompt changes etc., for now.

Just one opinion.